{
EnterKeyA㉺L[AyMaxLengthɒB玟̃Rg[
ړ悤ɂEditControl

1996/7/16 Gen.Y.Sakai
}
unit EEditEx;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls;

type
  TEnterEditEx = class(TEdit)
  private
    FGoNextOnMaxLength: Boolean;
  protected
    procedure Change; override;
    procedure KeyPress(var Key: Char); override;
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
  public
    constructor Create(AOwner: TComponent); override;
  published
    property MoveNextOnMaxLength:Boolean Read FGoNextOnMaxLength
                           write FGoNextOnMaxLength;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Samples', [TEnterEditEx]);
end;

constructor TEnterEditEx.Create(AOwner: TComponent);
begin
  inherited create(AOwner);
  FGoNextOnMaxLength := false;
end;

{enterL[Ŏ̃Rg[ɃtH[JXړ}
procedure TEnterEditEx.KeyPress(var Key: Char);
var
  MyForm: TForm;
begin
  if Key = #13 then begin
    MyForm := GetParentForm( Self );
    if not (MyForm = nil ) then
      SendMessage(MyForm.Handle, WM_NEXTDLGCTL, 0, 0);
    Key := #0;
  end;
  if Key <> #0 then inherited KeyPress(Key);
end;

{㉺L[ŃtH[JXړ}
procedure TEnterEditEx.KeyDown(var Key: Word; Shift: TShiftState);
var
  MyForm: TForm;
  Direction: Word;
begin
  if (Key = VK_UP) or (Key = VK_DOWN) then begin
    MyForm := GetParentForm( Self );
    if Key = VK_UP then Direction := 1
    else Direction :=0;
    if not (MyForm = nil ) then
      SendMessage(MyForm.Handle, WM_NEXTDLGCTL, Direction, 0);
  end
  else inherited KeyDown(Key, Shift);
end;

{MaxLengthɒB玟ControlɈړ}
procedure TEnterEditEx.Change;
var
  MyForm: TForm;
begin
  if (MaxLength <> 0) and
     (Length(Text) >= MaxLength) and
     FGoNextOnMaxLength then begin
    MyForm := GetParentForm( Self );
    if not (MyForm = nil ) then
      SendMessage(MyForm.Handle, WM_NEXTDLGCTL, 0, 0)
  end
  else inherited change;
end;

end.

